package sdlip.examples.demo;

import sdlip.SDLIPException;
/* holder for integer values */
import org.omg.CORBA.IntHolder;
/* transport module libraries */
import sdlip.helpers.*;
/* following packages are imported only if DOM-aware XMLObjects are used */
import sdlip.xml.dom.*;
import org.w3c.dom.*;
/* SDLIP XML element names */
import sdlip.SDLIP;

import java.applet.*;
import java.util.*;
import netscape.javascript.*;

/**
 * A sample applet-based SDLIP client.
 */

public class DemoClient extends Applet {

  JSObject win;
  final String PRIVILEGE = "UniversalConnect"; // "Netcaster";

  BasicNode root;

  StringBuffer frmLeft = new StringBuffer();
  StringBuffer frmMain = new StringBuffer();

  public void init() {
    super.init();

    //    root = new BasicNode("<a href='javascript:parent.frmTop.document.clientApp.addSource()'>Sources</a>");
    root = new BasicNode("<a target='frmMain' href='search.html'>Sources</a>");
    //    root.addChild(new ServerNode("Paintings", "http://xena.sdsc.edu:1234/Excelon"));
    //    root.addChild(new ServerNode("Geographical", "http://ucsb.edu/"));

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      //    netscape.security.PrivilegeManager.enablePrivilege("UniversalConnect");
      
      System.out.println("[DemoClient] started");
      //      showStatus("GUI Library Client ready!");

    } catch (Exception any) {
      System.err.println("[DemoClient] could not start: " + any);
    }
  }

  void setStatus(String text) {

    if(win != null) {
      Object[] buffer = new Object[1];
      buffer[0] = text;
      win.call("setWindowStatus", buffer);
    }
  }

  public boolean confirm(String msg) {
    return ((Boolean)win.eval("confirm('" + msg + "')")).booleanValue();
  }

  public void alert(String msg) {
    win.eval("alert('" + msg + "')");
  }

  public Object findObject(String hash) {

    try {
      return findObjectFrom(Integer.parseInt(hash), root);
    } catch (NumberFormatException nfe) {
      return null;
    }
  }

  public Object findObjectFrom(int hash, TreeNode n) {

    if(n.hashCode() == hash)
      return n;

    Object res = null;
    for(Enumeration en = n.children(); en.hasMoreElements();) {
      res = findObjectFrom(hash, (TreeNode)en.nextElement());
      if(res != null)
	break;
    }
    return res;
  }

  void redrawLeftFrame() {
    win.eval("parent.frmLeft.history.go(0)");
    //    win.eval("setTimeout('var d=parent.frmLeft.document; d.write(parent.frmTop.document.clientApp.getFrameContent(\"frmLeft\")); d.close(); alert(\"done\");');");
  }

  void redrawMainFrame() {
    win.eval("parent.frmMain.history.go(0)");
  }

  public String getFrameContent(String name) {

    //    System.err.println("CONTENT for " + name + " is " + frmLeft);

    if("frmLeft".equals(name))
      return frmLeft.toString();
    else
      return frmMain.toString();
  }

  void display(String mode, String text) {

    if("tree".equals(mode)) {
      frmLeft.setLength(0);
      frmLeft.append(text);
      redrawLeftFrame();
      return;
    } else {
      //      frmMain.setLength(0);
      //      frmMain.append(text);
      //      redrawMainFrame();
    Object[] buffer = new Object[2];
    buffer[0] = mode;
    buffer[1] = text;
    System.err.println("Writing to " + win);
    win.call("display", buffer);
    }

  }

  String SID;

  public String getSID() {
    return SID;
  }

  String img(String name) {
    return "<img src='images/" + name + ".gif' width=16 height=22 border=0 suppress=true>";
  }

  String opclImg(String imgname, TreeNode n) {
    return "<a href='javascript:parent.frmTop.document.clientApp.clickNode(" + n.hashCode() + ")'>" +
      img(imgname) + "</a>";
  }


  void drawNode(StringBuffer b, TreeNode n, int level, String leftSide, boolean isLastChild) {

    Enumeration en = n.children();

    if(n.getLabel() != null) {

      b.append("<tr><td><table border=0 cellpadding=0 cellspacing=0><tr><td valign=middle nowrap>");
	
      if(level > 0) {

	if (isLastChild) { //the last 'brother' in the children array 
	  if(!en.hasMoreElements())
	    b.append(leftSide + img("ftv2lastnode")); 
	  else if(n.getOpen())
	    b.append(leftSide + opclImg("ftv2mlastnode", n)); 
	  else
	    b.append(leftSide + opclImg("ftv2plastnode", n));
	  leftSide = leftSide + img("ftv2blank");
	}  else { 
	  if(!en.hasMoreElements())
	    b.append(leftSide + img("ftv2node")); 
	  else if(n.getOpen())
	    b.append(leftSide + opclImg("ftv2mnode", n)); 
	  else
	    b.append(leftSide + opclImg("ftv2pnode", n)); 
	  leftSide = leftSide + img("ftv2vertline");
	}
	//      leftSide += "&nbsp;&nbsp;";
	b.append("</td><td valign=center nowrap>&nbsp;");
      }

      b.append(n.getLabel());
      b.append("</td></tr></table></td></tr>\n");

      level++;

      //      for(int i = 0; i < level; i++)
      //	b.append("&nbsp;&nbsp;");
    }
    if(n.getOpen())
      while(en.hasMoreElements()) {
	TreeNode ch = (TreeNode)en.nextElement();
	drawNode(b, ch, level, leftSide, !en.hasMoreElements());
      }
  }

  public void addSource() {

    try {
      frmMain.setLength(0);
      redrawMainFrame();
    } catch (Throwable any) {
      procExc("addSource", any);
    }
  }

  public String clickNode(String nodeHash) {

    try {
      StringBuffer b = new StringBuffer();
      TreeNode n = (TreeNode)findObject(nodeHash);
      //      System.out.println("Clicked node " + n + " to be " + !n.getOpen());
      if(n != null)
	n.setOpen(!n.getOpen());

    } catch (Throwable any) {
      procExc("clickNode", any);
    } finally {
      setStatus("");
    }
    return updateTree(win);
  }


  public String addServer(JSObject win, String label, String host) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      setStatus("Loading server metadata...");
      root.addChild(new ServerNode(this, label, host));


    } catch (Throwable any) {
      procExc("addServer", any);
      return null;

    } finally {
      setStatus("");
    }

    return updateTree(win);
  }


  public String updateTree(JSObject win) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      StringBuffer b = new StringBuffer();

      b.append("<table cellpadding=0 cellspacing=0 border=0>");
      drawNode(b, root, 0, "", true);
      b.append("</table>");

      display("tree", b.toString());

      //      System.err.println(b.toString());

    } catch (Throwable any) {
      procExc("updateTree", any);
    }
    return null;
  }


  public void displaySearchForm(String collHash) {

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      StringBuffer b = new StringBuffer();
      CollectionNode n = (CollectionNode)findObject(collHash);
      n.displaySearchForm(b, "Search form", "Submit Query", true, "searchCollection", n.hashCode());
      display("results", b.toString());
      //      System.err.println(b.toString());

    } catch (Throwable any) {
      procExc("displaySearchForm", any);
    } finally {
      setStatus("");
    }
  }

  public String searchCollection(String hash, JSObject form) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      CollectionNode n = (CollectionNode)findObject(hash);
      setStatus("Searching...");
      ResultNode r = n.search(n, form);
      StringBuffer b = new StringBuffer();
      r.displayCurrentItem(b);
      //      System.err.println("DISPLAYING 2: " + b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("Search", any);
    } finally {
      setStatus("");
    }
    return updateTree(win);
  }


  public String retrieveMoreAttributes(String hash, JSObject form) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      ResultNode r = (ResultNode)findObject(hash);
      setStatus("Retrieving more attributes...");
      r.retrieveMoreAttributes(form);
      StringBuffer b = new StringBuffer();
      r.displayCurrentItem(b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("retrieveMoreAttributes", any);
    } finally {
      setStatus("");
    }
    return null;
  }

  public String makeAttributeChoice(String hash, JSObject form) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      ResultNode r = (ResultNode)findObject(hash);
      r.getCollection().makeAttributeChoice(form);
      StringBuffer b = new StringBuffer();
      r.displayCurrentItem(b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("makeAttributeChoice", any);
    } finally {
      setStatus("");
    }
    return null;
  }

  public String discardResult(String hash) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      ResultNode r = (ResultNode)findObject(hash);
      r.done();
      CollectionNode n = r.getCollection();
      r = (ResultNode)n.removeChild(r);
      StringBuffer b = new StringBuffer();
      if(r != null) {
	r.displayCurrentItem(b);
      } else {
	n.displaySearchForm(b, "Search form", "Submit Query", true, "searchCollection", n.hashCode());
      }
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("discardResult", any);
    } finally {
      setStatus("");
    }
    return updateTree(win);
  }

  public String attributeChoice(String hash) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      ResultNode r = (ResultNode)findObject(hash);
      StringBuffer b = new StringBuffer();
      r.getCollection().displaySearchForm(b, "Attribute choice", "Accept choice", false, "makeAttributeChoice", r.hashCode()); // use hashcode of r to know which result set to return to
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("attributeChoice", any);
    } finally {
      setStatus("");
    }
    return null;
  }


  public String nextResultItem(String hash, String num) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      ResultNode r = (ResultNode)findObject(hash);
      StringBuffer b = new StringBuffer();
      setStatus("Retrieving next result...");
      r.nextResult(Integer.parseInt(num));
      r.displayCurrentItem(b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("nextResultItem", any);
    } finally {
      setStatus("");
    }
    return null;
  }

  public void showResult(String hash) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());
      ResultNode r = (ResultNode)findObject(hash);
      StringBuffer b = new StringBuffer();
      r.displayCurrentItem(b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("showResult", any);
    } finally {
      setStatus("");
    }
  }

  public String setItemsPerPage(String hash, String value) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      ResultNode r = (ResultNode)findObject(hash);
      try {
	r.setItemsPerPage(Integer.parseInt(value));
      } catch (NumberFormatException nfe) {}
      StringBuffer b = new StringBuffer();
      r.displayCurrentItem(b);
      display("results", b.toString());

    } catch (Throwable any) {
      procExc("setItemsPerPage", any);
    } finally {
      setStatus("");
    }
    return null;
  }



  public String getDocs(JSObject win, String url, String sid, String reqID, String docsToGet) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);

      doGetDocs(url, sid, reqID, docsToGet);
    } catch (Throwable any) {
      procExc("getDocs", any);
    }
    return null;
  }

  public String discoverMetadata(JSObject win, String url) {
    
    this.win = win;
    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      
      doDiscoverMetadata(url);
    } catch (Throwable any) {
      procExc("Metadata", any);
    }
    return null;
  }

  public String getSessionInfo(JSObject win, String url, String SID) {
    
    this.win = win;
    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      
      doGetSessionInfo(url, SID);
    } catch (Throwable any) {
      procExc("getSessionInfo", any);
    }
    return null;
  }

  public String extendStateTimeout(JSObject win, String url, String SID, String addTime) {
    
    this.win = win;
    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      
      doExtendStateTimeout(url, SID, addTime);
    } catch (Throwable any) {
      procExc("extendStateTimeout", any);
    }
    return null;
  }

  public String cancelRequest(JSObject win, String url, String SID, String reqID) {
    
    this.win = win;
    try {
      netscape.security.PrivilegeManager.enablePrivilege(PRIVILEGE);
      
      doCancelRequest(url, SID, reqID);
    } catch (Throwable any) {
      procExc("cancelRequest", any);
    }
    return null;
  }

  void procExc(String method, Throwable exc) {
    try {
      String msg = null;
      if(exc instanceof sdlip.SDLIPException) {
	sdlip.SDLIPException sdlip = (sdlip.SDLIPException)exc;
	msg = "SDLIP exception (" + sdlip.getCode() + "): " + sdlip.getReason();
      } else
	msg = "Could not perform method: " + method + ", reason: " + exc.getMessage();
      System.err.println(msg);
      exc.printStackTrace(System.err);
      display("err", msg);
    } catch (Throwable any) {
      System.err.println("Could not print exception info for method " + method + ", exc: " + exc);
    }
  }
  
  DBG dbg = new DBG(DBG.SHORT);

  private String replace( String src, String in, String out ) {
    int pos = src.indexOf(in);
    
    while (pos != -1) {
      src = src.substring(0,pos) + out + src.substring(pos+in.length());
      pos = src.indexOf(in);
    }   
    return src;
  }

  void doGetSessionInfo(String url, String sid) throws Exception {

    StringBuffer b = new StringBuffer("<h2>Session info for " + url + ", SID:" + sid + "</h2>");

    ClientTransportModule tm = ClientTransportModule.create(url);
    tm.setDBG(dbg);

    IntHolder hExpectedTotal = new IntHolder();
    IntHolder hStateTimeout = new IntHolder();

    tm.getSessionInfo(Integer.parseInt(sid), hExpectedTotal, hStateTimeout);

    b.append("<p>EXPECTED TOTAL: " + ResultNode.expectedTotalString(hExpectedTotal.value));
    b.append("<p>TIMEOUT: " + hStateTimeout.value);
    
    display("results", b.toString());
  }

  void doCancelRequest(String url, String sid, String reqID) throws Exception {

    StringBuffer b = new StringBuffer("<h2>Result from " + url + ", SID:" + sid + "</h2>");

    ClientTransportModule tm = ClientTransportModule.create(url);
    tm.setDBG(dbg);
    
    tm.cancelRequest(Integer.parseInt(sid), Integer.parseInt(reqID));

    if(Integer.parseInt(reqID) == 0)
      b.append("<p>Session canceled");
    else
      b.append("<p>Request canceled");
    
    display("results", b.toString());
  }

  void doExtendStateTimeout(String url, String sid, String addTime) throws Exception {

    StringBuffer b = new StringBuffer("<h2>" + url + ", SID:" + sid + "</h2>");
    
    ClientTransportModule tm = ClientTransportModule.create(url);
    tm.setDBG(dbg);
    
    IntHolder hTimeAllotted = new IntHolder();
    
    tm.extendStateTimeout(Integer.parseInt(sid),
			  Integer.parseInt(addTime),
			  hTimeAllotted);
    
    b.append("<p>TIME ALLOTTED: " + hTimeAllotted.value);
    
    display("results", b.toString());
  }

  void doDiscoverMetadata(String url) throws Exception {

    StringBuffer b = new StringBuffer("<h2>Metadata for " + url + "</h2>");

    ClientTransportModule tm = ClientTransportModule.create(url);
    tm.setDBG(dbg);

    /* the result will be held in a DOM-enabled SDLIP.xml.dom.XMLObject */
    XMLObject result = new XMLObject();
    
    /* Metadata */
    
    tm.getInterface(result);
    b.append("<h3>Supported Interfaces</h3><pre>" + replace(result.getPrettyString(), "<", "&lt;") + "</pre>");
    
    tm.getSubcollectionInfo(result);
    b.append("<h3>Subcollections</h3><pre>" + replace(result.getPrettyString(), "<", "&lt;") + "</pre>");
    
    /* get a DOM element from an XMLObject */
    Element subcols = result.getElement();
    
    /* iterate over all found subcollections */
    NodeList colList = DOMUtil.getChildElements(subcols, SDLIP.subcol);
    for(int i=0; i < colList.getLength(); i++) {
      
      Element eCol = (Element)colList.item(i);
      String colName = DOMUtil.getChildText(eCol, SDLIP.subcolName);
      
      /* retrieve properties of the subcollection */
      tm.getPropertyInfo(colName, result);
      b.append("<h3>Properties of " + colName + "</h3><pre>" + replace(result.getPrettyString(), "<", "&lt;") + "</pre>");
    }
    display("results", b.toString());
  }

  void printResults(StringBuffer b, XMLObject result) {
    /* get the top XML element from an XMLObject */
    Element searchResult = result.getElement();
    
    b.append("<ul>");
    /* iterate over all found documents */
    NodeList docList = DOMUtil.getChildElements(searchResult, SDLIP.doc);
    for(int i=0; i < docList.getLength(); i++) {
      
      /* print document ID */
      Element eDoc = (Element)docList.item(i);
      b.append("<li><b>[" + DOMUtil.getChildText(eDoc, SDLIP.DID) + "]</b>");
      b.append("<br><table>");
      
      /* print all document properties in format NAME = "VALUE" */
      Element ePropList = DOMUtil.getChild(eDoc, SDLIP.propList);
      NodeList propList = DOMUtil.getChildElements(ePropList, "*");
      for(int j=0; j < propList.getLength(); j++) {
	Element eProp = (Element)propList.item(j);
	String tagName = eProp.getTagName();
	String propValue = DOMUtil.getText(eProp);
	if(propValue != null && propValue.startsWith("http:"))
	  propValue = "<a href='" + propValue + "'>" + propValue + "</a>";
	b.append("<tr><td><a href='" + tagName + "'><b>" +
		 "<font color='darkblue'>" + NestedAttribute.getName(tagName) + "</font></a></td><td>" + propValue + "</td></tr>");
      }
      b.append("</table></li>");
    }
    b.append("</ul>");
    
    //      b.append("<p>RESULT:\n" + result.getPrettyString());
  }

  void doGetDocs(String url, String serverSID, String reqID, String docsToGet) throws Exception  {

    StringBuffer b = new StringBuffer("<h2>Results " + docsToGet + " from " + url + ", SID: " + serverSID + "</h2>");

    ClientTransportModule tm = ClientTransportModule.create(url);
    tm.setDBG(dbg);
    
    XMLObject result = new XMLObject();

    tm.getDocs(Integer.parseInt(serverSID),
	       Integer.parseInt(reqID),
	       null,
	       docsToGet,
	       result);

    printResults(b, result);
    
    display("results", b.toString());
    
  }

}
