package sdlip.examples.demo;

import sdlip.SDLIPException;
/* holder for integer values */
import org.omg.CORBA.IntHolder;
/* transport module libraries */
import sdlip.helpers.*;
/* following packages are imported only if DOM-aware XMLObjects are used */
import sdlip.xml.dom.*;
import org.w3c.dom.*;
/* SDLIP XML element names */
import sdlip.SDLIP;

/**
 * A TreeNode representing an SDLIP server.
 */

public class ServerNode extends BasicNode {

  DemoClient client;
  String host;
  //  Element metadata;

  public ServerNode(DemoClient client, String label, String serverHost) throws Exception {
    super();
    this.client = client;
    this.label = "<b><font color=darkblue>" + label + "</b>";
    this.host = serverHost;
    getMetadata();
  }

  public String getHost() {
    return host;
  }

  public DemoClient getClient() {
    return client;
  }

  public void getMetadata() throws Exception {

    ClientTransportModule tm = ClientTransportModule.create(host);
    tm.setDBG(new DBG(DBG.VERBOSE));

    /* the result will be held in a DOM-enabled SDLIP.xml.dom.XMLObject */
    XMLObject result = new XMLObject();
    
    /* Metadata */
    
    //    tm.getInterface(result);
    //    metadata = result.getElement();

    //    b.append("<h3>Supported Interfaces</h3><pre>" + replace(result.getPrettyString(), "<", "&lt;") + "</pre>");
    
    tm.getSubcollectionInfo(result);
    //    b.append("<h3>Subcollections</h3><pre>" + replace(result.getPrettyString(), "<", "&lt;") + "</pre>");
    
    /* get a DOM element from an XMLObject */
    Element subcols = result.getElement();
    
    /* iterate over all found subcollections */
    NodeList colList = DOMUtil.getChildElements(subcols, SDLIP.subcol);
    for(int i=0; i < colList.getLength(); i++) {
      
      Element eCol = (Element)colList.item(i);
      boolean isDefault = DOMUtil.getChild(eCol, SDLIP.defaultSubcol) != null;

      addChild(new CollectionNode(eCol, this, isDefault));
    }

  }
  
}
