/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */

package sdlip.http;

import java.io.*;
import java.net.*;
import java.util.*;

public class HTTPClient {

  public final static int DEFAULT_PORT = 80;

  URL url;
  OutputStream out;
  InputStream in;

  public HTTPClient(String url) throws MalformedURLException {
    
    this(new URL(url));
  }
  
  public HTTPClient(URL url) {
    
    this.url = url;
  }

  synchronized void checkOpen() throws IOException {
    
    if(out == null) {
      
      Socket socket = new Socket( url.getHost(), url.getPort() > 0 ? url.getPort() : DEFAULT_PORT );
      out = socket.getOutputStream();
      in = socket.getInputStream();
    }
  }

  public OutputStream getOutputStream() throws IOException {
    checkOpen();
    return out;
  }

  public InputStream getInputStream() throws IOException {
    checkOpen();
    return in;
  }
}
